# Regenerate billing transactions

Use this operation to generate billing transactions. This call is useful in the following two use cases: 
* During customer onboarding, there is a common scenario when customers perform data backfill or data fixes. To synchronize these changes from Billing to Revenue, use this API operation to regenerate billing transaction objects.
* Customers choose to experiment with their use cases in the Sandbox environment before implementing them in the Production environment. During this experimentation phase, customers not only interact with data but also use this API operation to regenerate transaction objects.

Endpoint: POST /v1/uno-regenerate/billing-transaction
Version: 2026-09-18
Security: bearerAuth

## Header parameters:

  - `Idempotency-Key` (string)
    Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. 

With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.

  - `Accept-Encoding` (string)
    Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. 

If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.

  - `Content-Encoding` (string)
    Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.

  - `Zuora-Track-Id` (string)
    A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.

The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').

  - `Zuora-Entity-Ids` (string)
    An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.

  - `Zuora-Org-Ids` (string)
    Comma separated IDs. If you have Zuora Multi-Org enabled, 
you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.

The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.

  - `Zuora-Version` (string)
    The minor API version.

For a list of available minor versions, see API upgrades.

## Query parameters:

  - `onlyReSend` (boolean)
    If onlyReSend is true, existing billing transaction records are not overwritten; they are resent with regenerate_flag = Y. 
If onlyReSend is false, behaviour depends on reMigrate: reMigrate=true -> recalculate, overwrite, send
with regenerate_flag = Y; -> reMigrate = false -> do not overwrite, and may resend existing records with regenerate_flag = N.


Note: If onlyReSend is true, the reMigrate field cannot be true.

'

  - `reMigrate` (boolean)
    If reMigrate is false, existing billing transaction records are not overwritten. When onlyReSend is also default:false, existing records may still be resent to Zuora Revenue with regenerate_flag = N, and
are not recalculated from updated source documents.
If reMigrate is true, records are recalculated from source, overwritten in the database, and sent with regenerate_flag = Y (unless exclusion flags prevent the send).


Note: If onlyReSend is true, the reMigrate field cannot be true.

'
Notes: 
- Both reMigrate and onlyReSend are optional.
- Parameter names are case-sensitive.
- Values must be true or false, not Y or N.
- Unrecognized names are ignored, and defaults are used. The API may still return success: true. 
- reMigrate and onlyReSend cannot both be true.

## Request fields (application/json):

  - `id` (string)
    ID of Invoice, CreditMemo, DebitMemo, or InvoiceItemAdjustment.

  - `number` (string)
    Number of Invoice, CreditMemo, DebitMemo, or InvoiceItemAdjustment.
    Example: "CM00000001"

  - `type` (string)
    The type of business object for which you want to generate the transactions.
    Enum: "Invoice", "CreditMemo", "DebitMemo", "InvoiceItemAdjustment"

## Response 200 fields (application/json):

  - `idList` (array)
    A list of the IDs for the business objects for which you generate the transactions.

  - `reasons` (array)

  - `reasons.code` (string)
    The error code of response.

  - `reasons.message` (string)
    The detail information of the error response.

  - `success` (boolean)
    Indicates whether the call succeeded.

## Response 500 fields (application/json):

  - `reasons` (array)
    Example: [{"code":"ObjectNotFound","message":"Notification definition with id 6e569e1e05f040eda51a927b140c0ac1 does not exist"}]

  - `reasons.code` (string)
    The error code of response.

  - `reasons.message` (string)
    The detail information of the error response

## Response 4XX fields (application/json):

  - `processId` (string)
    The ID of the process that handles the operation.

  - `reasons` (array)
    The container of the error code and message. This field is available only if the success field is false.

  - `reasons.code` (string)
    The error code of response.

  - `reasons.message` (string)
    The detail information of the error response

  - `requestId` (string)
    Unique identifier of the request.

  - `success` (boolean)
    Indicates whether the call succeeded.


